var r = /* @__PURE__ */ ((e) => (e.Dot = ".", e.OptDot = "?.", e.LBracket = "[", e.RBracket = "]", e.Colon = ":", e.Minus = "-", e.LCurly = "{", e.RCurly = "}", e.Identifier = "identifier", e.Integer = "integer", e.String = "string", e.Symbol = "symbol", e.Illegal = "illegal", e))(r || {});
class L {
  constructor(t) {
    this.readPosition = 0, this.afterInteger = !1, this.source = t, this.readChar();
  }
  next() {
    let t;
    if (this.afterInteger && (this.afterInteger = !1, C(this.ch) || y(this.ch)))
      return t = [r.Illegal, this.ch, this.position, "a numeric literal must not be immediately followed by an identifier start or decimal digit"], this.readChar(), { value: t };
    switch (this.skipWhitespaces(), this.ch) {
      case void 0:
        return { done: !0, value: void 0 };
      case ".":
        t = [r.Dot, void 0, this.position];
        break;
      case "?":
        t = this.readOptDot();
        break;
      case "[":
        t = [r.LBracket, void 0, this.position];
        break;
      case ":":
        t = [r.Colon, void 0, this.position];
        break;
      case "]":
        t = [r.RBracket, void 0, this.position];
        break;
      case "-":
        t = [r.Minus, void 0, this.position];
        break;
      case "{":
        t = [r.LCurly, void 0, this.position];
        break;
      case "}":
        t = [r.RCurly, void 0, this.position];
        break;
      case "0":
        switch (this.afterInteger = !0, this.peekChar()) {
          case "b":
          case "B":
            return { value: this.readBinaryInteger() };
          case "o":
          case "O":
            return { value: this.readOctalInteger() };
          case "x":
          case "X":
            return { value: this.readHexInteger() };
          default:
            t = [r.Integer, 0, this.position];
        }
        break;
      case '"':
      case "'":
        t = this.readString();
        break;
      case "$":
      case "_":
        return { value: this.readIdentifier() };
      default:
        if (E(this.ch))
          return this.afterInteger = !0, { value: this.readDecimalInteger() };
        if (y(this.ch))
          return { value: this.readIdentifier() };
        t = [r.Illegal, this.ch, this.position];
    }
    return this.readChar(), { value: t };
  }
  skipWhitespaces() {
    for (; M(this.ch); )
      this.readChar();
  }
  readOptDot() {
    return this.readChar(), this.ch === "." ? [r.OptDot, void 0, this.position - 1] : [r.Illegal, `?${this.ch}`, this.position - 1, "? must be followed by ."];
  }
  // https://www.ecma-international.org/ecma-262/11.0/index.html#prod-DecimalIntegerLiteral
  readDecimalInteger() {
    const { position: t } = this;
    do
      this.readChar();
    while (C(this.ch));
    return [r.Integer, Number(this.source.slice(t, this.position)), t];
  }
  // https://www.ecma-international.org/ecma-262/11.0/index.html#prod-BinaryIntegerLiteral
  readBinaryInteger() {
    const { position: t } = this;
    this.readChar(), this.readChar();
    const { ch: i } = this;
    if (this.readChar(), !b(i))
      return [r.Illegal, this.source.slice(t, this.position), t, "expected binary digit"];
    for (; b(this.ch); )
      this.readChar();
    return [r.Integer, Number(this.source.slice(t, this.position)), t];
  }
  // https://www.ecma-international.org/ecma-262/11.0/index.html#prod-OctalIntegerLiteral
  readOctalInteger() {
    const { position: t } = this;
    this.readChar(), this.readChar();
    const { ch: i } = this;
    if (this.readChar(), !w(i))
      return [r.Illegal, this.source.slice(t, this.position), t, "expected octal digit"];
    for (; w(this.ch); )
      this.readChar();
    return [r.Integer, Number(this.source.slice(t, this.position)), t];
  }
  // https://www.ecma-international.org/ecma-262/11.0/index.html#prod-HexIntegerLiteral
  readHexInteger() {
    const { position: t } = this;
    this.readChar(), this.readChar();
    const { ch: i } = this;
    if (this.readChar(), !S(i))
      return [r.Illegal, this.source.slice(t, this.position), t, "expected hexadecimal digit"];
    for (; S(this.ch); )
      this.readChar();
    return [r.Integer, Number(this.source.slice(t, this.position)), t];
  }
  // https://www.ecma-international.org/ecma-262/11.0/index.html#sec-literals-string-literals
  // Simplified: only supports escaping the following characters: " ' \
  readString() {
    const { position: t } = this, i = this.ch;
    do
      for (this.readChar(); this.ch === "\\"; )
        this.readChar(), this.readChar();
    while (this.ch !== void 0 && this.ch !== i);
    return this.ch === void 0 ? [r.Illegal, this.source.slice(t, this.position), t, "unterminated string literal"] : [r.String, this.source.slice(t + 1, this.position).replace(/\\(.)/g, "$1"), t];
  }
  // https://www.ecma-international.org/ecma-262/11.0/index.html#prod-IdentifierName
  readIdentifier() {
    const { position: t } = this;
    do
      this.readChar();
    while (A(this.ch));
    return [r.Identifier, this.source.slice(t, this.position), t];
  }
  readChar() {
    this.ch = this.source[this.position = this.readPosition++];
  }
  peekChar() {
    return this.source[this.readPosition];
  }
  [Symbol.iterator]() {
    return this;
  }
}
function M(e) {
  return e === " " || e === "	" || e === "\v" || e === "\f" || e === " " || e === "\uFEFF" || /\p{Zs}/u.test(e);
}
function E(e) {
  return e >= "1" && e <= "9";
}
function C(e) {
  return e >= "0" && e <= "9";
}
function b(e) {
  return e === "0" || e === "1";
}
function w(e) {
  return e >= "0" && e <= "7";
}
function S(e) {
  return C(e) || e >= "a" && e <= "f" || e >= "A" && e <= "F";
}
const v = /\p{ID_Start}/u;
function y(e) {
  return e === void 0 ? !1 : e === "$" || e === "_" || v.test(e);
}
const T = /[$\p{ID_Continue}\u200c\u200d]/u;
function A(e) {
  return e === void 0 ? !1 : e === "$" || T.test(e);
}
var c = /* @__PURE__ */ ((e) => (e[e.PropIndex = 0] = "PropIndex", e[e.Slice = 1] = "Slice", e))(c || {}), $ = /* @__PURE__ */ ((e) => (e[e.PathArgument = 0] = "PathArgument", e))($ || {});
function B(e) {
  return (e == null ? void 0 : e[0]) === 0;
}
const p = /* @__PURE__ */ new Map();
function R(e) {
  const t = e.reduce((s, o, n) => `${s}{${n - 1}}${o}`);
  if (p.has(t))
    return p.get(t);
  const i = Array.from(new F(t));
  return p.set(t, i), i;
}
class F {
  constructor(t) {
    this.lexer = new L(t), this.readToken(), this.readToken();
  }
  next() {
    if (this.token === void 0)
      return { done: !0, value: null };
    let t;
    switch (this.token[0]) {
      case r.Dot:
        t = this.readProp();
        break;
      case r.LBracket:
        t = this.readBracket();
        break;
      case r.OptDot:
        t = this.nextToken[0] === r.LBracket ? this.readBracket() : this.readProp();
        break;
      default:
        throw SyntaxError(`unexpected ${this.token[0]}`);
    }
    return this.readToken(), { value: t };
  }
  readProp() {
    const t = this.token[0] === r.OptDot;
    return this.readToken(), this.assertTokenType(r.Identifier), [c.PropIndex, this.token[1], t];
  }
  readBracket() {
    var s;
    const t = this.token[0] === r.OptDot;
    t && this.readToken(), this.readToken();
    let i;
    switch ((s = this.token) == null ? void 0 : s[0]) {
      case r.LCurly:
      case r.Minus:
      case r.Integer:
        i = this.readIndexOrSlice(t);
        break;
      case r.String:
      case r.Symbol:
        i = [c.PropIndex, this.token[1], t];
        break;
      case r.Colon:
        i = this.readSlice(void 0, t);
        break;
      default:
        throw new SyntaxError(
          this.unexpectedTokenMessage([r.LCurly, r.Minus, r.Integer, r.String, r.Symbol, r.Colon])
        );
    }
    return this.readToken(), this.assertTokenType(r.RBracket), i;
  }
  readIndexOrSlice(t) {
    var s, o;
    const i = ((s = this.token) == null ? void 0 : s[0]) === r.LCurly ? this.readArg() : this.readInteger();
    return ((o = this.nextToken) == null ? void 0 : o[0]) === r.Colon ? this.readSlice(i, t) : [c.PropIndex, i, t];
  }
  readArg() {
    if (this.readToken(), this.token[0] !== r.Integer)
      throw new SyntaxError(this.unexpectedTokenMessage([r.Integer]));
    const t = this.token[1];
    return this.readToken(), this.assertTokenType(r.RCurly), [$.PathArgument, t];
  }
  readSlice(t, i) {
    var o, n, u, h;
    this.nextToken[0] === r.Colon && this.readToken();
    let s;
    return (((o = this.nextToken) == null ? void 0 : o[0]) === r.Integer || ((n = this.nextToken) == null ? void 0 : n[0]) === r.Minus || ((u = this.nextToken) == null ? void 0 : u[0]) === r.LCurly) && (this.readToken(), s = ((h = this.token) == null ? void 0 : h[0]) === r.LCurly ? this.readArg() : this.readInteger()), [c.Slice, t, s, i];
  }
  readInteger() {
    if (this.token[0] === r.Integer)
      return this.token[1];
    if (this.readToken(), this.token[0] !== r.Integer)
      throw new SyntaxError(this.unexpectedTokenMessage([r.Integer]));
    return -this.token[1];
  }
  assertTokenType(...t) {
    var i;
    if (!t.includes((i = this.token) == null ? void 0 : i[0]))
      throw new SyntaxError(this.unexpectedTokenMessage(t));
  }
  readToken() {
    this.token = this.nextToken, this.nextToken = this.lexer.next().value;
  }
  unexpectedTokenMessage(t) {
    var s;
    let i = `unexpected ${((s = this.token) == null ? void 0 : s[0]) ?? "EOF"}`;
    return this.token && (i += ` at position ${this.token[2] + 1}`), t.length === 1 ? i += `, expected ${t}` : i += `, expected one of ${t}`, i;
  }
  [Symbol.iterator]() {
    return this;
  }
}
function I(e, t, i, s, o) {
  if (e.length === 0)
    return s(i, ...o);
  const [n, ...u] = e;
  switch (n[0]) {
    case c.PropIndex: {
      if (n[2] && i == null)
        return i;
      const h = B(n[1]) ? t[n[1][1]] : n[1];
      if (typeof h == "function") {
        if (i == null)
          return [];
        if (Array.isArray(i)) {
          let f = !1;
          const k = i.map((a, O) => {
            if (!h(a, O))
              return a;
            const m = I(u, t, a, s, o);
            return f || (f = m !== a), m;
          });
          return f ? k : i;
        }
      }
      const l = i == null ? void 0 : i[h], d = I(u, t, l, s, o);
      if (d === l)
        return i;
      const g = _(i, N(h));
      return g[h] = d, g;
    }
    case c.Slice: {
      if (i == null)
        return n[3] ? i : [];
      if (!Array.isArray(i))
        throw TypeError(`Slice notation is not defined for ${typeof i}`);
      const [h, l] = H(i, P(n[1], t), P(n[2], t));
      let d = !1;
      const g = i == null ? void 0 : i.slice(h, l).map((k) => {
        const a = I(u, t, k, s, o);
        return d || (d = a !== k), a;
      });
      if (!d)
        return i;
      const f = [...i];
      return f.splice(h, l - h, ...g), f;
    }
    default:
      throw TypeError("not implemented");
  }
}
function _(e, t) {
  if (e == null)
    return t ? [] : {};
  if (typeof e != "object")
    throw TypeError("not implemented");
  return Array.isArray(e) ? [...e] : { ...e };
}
function H(e, t, i) {
  return [D(e, t ?? 0), D(e, i ?? (e == null ? void 0 : e.length) ?? 0)];
}
function D(e, t) {
  return t >= 0 ? t : e == null || !("length" in e) ? 0 : Math.max(e.length + t, 0);
}
function P(e, t) {
  if (!B(e))
    return e;
  const i = t[e[1]];
  if (i != null && !Number.isSafeInteger(i))
    throw TypeError("Slice bounds must be integers or undefined/null");
  return i;
}
function N(e) {
  return Number.isSafeInteger(e) && e >= 0;
}
function x(e) {
  return (t, i, ...s) => {
    const o = R(t.slice(1));
    return (...n) => I(o, s, i, e, n);
  };
}
const V = x((e, ...t) => e == null ? t : [...e, ...t]), W = x((e, t) => t), Z = x((e, t, ...i) => t(e, ...i));
export {
  x as apply,
  V as push,
  W as set,
  Z as update
};
